; convert_hatch.lsp
; Copyright (C) 1999 Visio Corporation.  All Rights Reserved.

; By Ronald Prepchuk

;The following routine will convert AutoCADtm HATCH objects into IntelliCAD INSERT 
;objects, making them compatible with IntelliCAD editing commands.  It currently only 
;works with associative hatches created with BHATCH.

(defun C:CHATCH (/ SS COUNT EN EL EN2 EN3)
(setvar "CMDECHO" 0)
(setq SS (ssget "X" '((0 . "HATCH"))))
(setq COUNT 0)
(repeat (sslength SS)
  (setq EN (ssname SS COUNT))
  (setq EL (entget EN))
  (setq EN2 (cdr (assoc 330 EL)));boundary entity, check to see if it still exists
  (entdel EN)
  (setq EN3 (entlast))
  (command "._HATCH" (cdr (assoc 2 EL)) (cdr (assoc 41 EL)) (cdr (assoc 52 EL)) EN2 "")
  (if (eq EN3 (entlast)) 
    (progn
      (entdel EN);bring back old hatch if new hatch failed
      (redraw EN 3)
      (princ "\nThis HATCH entity could not be converted")
      )
    )
  (setq COUNT (1+ COUNT))
  )
(princ)
)

(princ "\nAvailable commands are: CHATCH")
(princ)
